
#####################################################################
#
# Application Generator; version 2.0
# (C) 2003-2005, Alex S. <alex@theparticle.com>
# http://www.theparticle.com/
#
#####################################################################

use pxml;
use strict;

open my $out,">gen/dbres.sql" or die $!;
    
print $out "-- This file is auto GENERATED from metadata.xml file.\n";
print $out "-- DO NOT MODIFY THIS FILE!!!\n";
print $out "-- All changes should be made to metadata.xml instead.\n\n\n";

my $meta = new pxml(file => "metasecurity.xml");

my %allrecs = ();

# loop for all records
for my $r ($meta->query('*/@record')){
    my $name = $r->query('%name');
    my @attr;
    my %attr;
    $allrecs{$name} = {cnt=>1,objs=>{}} if !defined($allrecs{$name});
    
    for my $a ($r->query('*/@attribute')){
        my $name = $a->query('%name');
        my $value = $a->query('*/$');
        push @attr,{name=>$name,value=>$value};
        $attr{$name} = $value;
    }
    if(defined $attr{name} || defined $attr{username}){
        my $nname = $attr{username} ? $attr{username}:$attr{name};
        if(defined $attr{id}){
            $allrecs{$name}{objs}{$nname} = $attr{id};
        }else{
            $allrecs{$name}{objs}{$nname} = $allrecs{$name}{cnt};
            $allrecs{$name}{cnt}++;
        }
    }

    print $out "insert into $name (".
        join(',',map {$_->{name}} @attr).
        ') values ('.
        join(',',map {my $s = $_->{value};$s =~ s/\'/\\\'/g;"'".$s."'"} @attr).
        ");\n\n";
}


# loop for all userroles
for my $r ($meta->query('*/@userrole')){
    my $user = $r->query('%user');
    my $role = $r->query('%role');

    my $userid = $allrecs{user}{objs}{$user};
    my $roleid = $allrecs{role}{objs}{$role};

    print $out "insert into userrole (userid,roleid) values ($userid,$roleid);\n\n";
}

# loop for all rolepermissions
for my $r ($meta->query('*/@rolepermission')){
    my $role = $r->query('%role');
    my $permission = $r->query('%permission');
    my $roleid = $allrecs{role}{objs}{$role};
    my $permissionid = $allrecs{permission}{objs}{$permission};
    print $out "insert into rolepermission (roleid,permissionid) values ($roleid,$permissionid);\n\n";
}

close $out;


