<?php

session_start();

include_once("db.php");
include_once("User.php");
include_once("Resource.php");

$current_user = NULL;
$current_resource = NULL;

// get parameters
$q = $HTTP_GET_VARS['q'];

if(!isset($q)){
    $q = "index";
}else{
    if(isset($HTTP_GET_VARS['pq'])){
        $HTTP_SESSION_VARS['pq'] = $HTTP_GET_VARS['pq'];
    }
}

// connect to db
$link = db_open();

// if no db
if(!$link){
    Header("Location: nodb.php");
    exit;
}

// get the resource user wants
$current_resource = queryResourceByName($q);

// is it a valid resource?
if(!$current_resource){
    Header("Location: error.php");
    exit;
}

if($HTTP_SESSION_VARS['login_id'] > 0){
    $current_user = dbGetUser((int)($HTTP_SESSION_VARS['login_id']));
    if($current_user){
        queryUserRequestUpdate($current_user->id);

        // fill up user $roles array.
        $r = queryUserRoles($current_user->id);
        if($r){
            foreach ($r as $value) {
                $roles[ $value['role'] ] = 1;
            }
        }
    }
}

// does this resource require login?
if($current_resource->secure){
    if(!$current_user){
        Header("Location: get.php?q=user/login");
        exit;
    }else{
        $r = queryUserHasPermission(
            $current_user->id,
            $current_resource->permission);
        if(!$r['N']){
            Header("Location: accessdenied.php");
            exit;
        }
    }
}

?>
